' Herv DEBRAY - Division Informatique du Rectorat de Crteil - 15/12/2006

Const ForReading = 1, ForWriting = 2, ForAppending = 8  

Set WshShell = Wscript.CreateObject("Wscript.Shell")
Set WshSysEnv = WshShell.Environment("Process")
Set fso = CreateObject("Scripting.FileSystemObject")
pasnet=0
L0 = "INE;Prnom 1;Prnom 2;Prnom 3;Nom;Sexe;Date de naissance;Commune de naissance;Pays de naissance;Division"
'Fonction d'extraction de la division
Function Extract_div(Ligne)

Tableau=split(Ligne,";",-1,1)

Tableau(9)=Replace(Tableau(9),"/","_")
Tableau(9)=Replace(Tableau(9)," ","_")

Extract_div = Tableau(9)

End Function

Function Test_Assr(Ligne)

Tableau=split(Ligne,";",-1,1)

MaDate=Tableau(6)
If ((CDate(MaDate)>CDate("31/12/1990")) and (CDate(MaDate)<CDate("31/12/1991"))) Then
Test_Assr = "ASSR1"
Elseif ((CDate(MaDate)>CDate("31/12/1992")) and (CDate(MaDate)<CDate("31/12/1993"))) Then
Test_Assr = "ASSR2"
End if

End Function

   
' Dfinition d'une fonction transformant une ligne de type sconet en une ligne de type Assr
Function LineSco_LineAssr(Ligne,RNE,ETAB)

	Tableau=split(Ligne,";",-1,1)
	LineSco_LineAssr=Tableau(0)&";EDU;"

	Select Case Tableau(5)
		Case "F"
			Tableau(5)="0"
		Case "M"
			Tableau(5)="1"
	End Select

	Tableau(9)=Replace(Tableau(9),"/","_")
	Tableau(9)=Replace(Tableau(9)," ","_")


	For i=1 to 6
	
		LineSco_LineAssr=LineSco_LineAssr&Tableau(i)&";"
	Next
	If Tableau(7) = "-" Then

		LineSco_LineAssr=LineSco_LineAssr&Tableau(8)&";"&Tableau(9)&";"&RNE&";"&ETAB
	Else
		LineSco_LineAssr=LineSco_LineAssr&Tableau(7)&";"&Tableau(9)&";"&RNE&";"&ETAB
	End If

End Function

' Dfinition d'un fonction qui test les champs vides

Function test_champs(Ligne)

Tableau=split(Ligne,";",-1,1)

If Tableau(7)&Tableau(8) = "--" Then
	test_champs=0
ELSE
	test_champs=Len(Tableau(0))*Len(Tableau(1))*Len(Tableau(4))*Len(Tableau(5))*Len(Tableau(6))*Len(Tableau(9))
End IF

End Function


'Demande du RNE du type d'tablissement et du nom du fichier

RNE_Orig=InputBox("Entrer le RNE de l'tablissement d'origine des candidats","Assr session 2007")
RNE_Orig=UCase(RNE_Orig)

If RNE_Orig <> "" Then
	Type_Etab=InputBox("Entrez le type d'tablissement : CLG,LPO,GRETA...","Assr session 2007")
	Type_Etab=UCase(Type_Etab)
End If

If (RNE_Orig <> "") and (Type_Etab <> "") Then
	fsconet=InputBox("Entrez le nom du fichier d'extraction sconet (format CSV). Exemple : monfichiersconet.csv","Assr session 2007")
End If



If (RNE_Orig <> "") and (Type_Etab <> "") and (fsconet <> "") and (fso.FileExists (fsconet)) Then
	par_div=Msgbox("Souhaitez-vous gnrer un fichier par classe ?",36,"Assr session 2007")
	'Nom du fichier assr
	
	fscopanet=Left(fsconet,len(fsconet)-4)&"_incomplet.csv"


	
	Set ts = fso.OpenTextFile(fsconet, ForReading, True)  

        
	While ts.AtEndOfStream <> True
                 ON Error Resume Next
  		 LigneSconet = ts.Readline
		If test_champs(LigneSconet)=0 Then
			On Error Resume Next 
		    Set tb = fso.OpentextFile(fscopanet, ForWriting,True)
			If pasnet=0 Then tb.writeLine L0
			tb.writeLine LigneSconet
			pasnet=1
			On Error GoTo 0
		Else
   
   			If (LigneSconet <> "") and (left(LigneSconet,3)<>"INE") Then
				div=Extract_div(LigneSconet)
				LigneAssr=LineSco_LineAssr(LigneSconet,RNE_Orig,Type_Etab)
				If par_div = 6 Then 
					fassr=Left(fsconet,len(fsconet)-4)&"_assr_"&div&".csv"
				Else
					fassr=Left(fsconet,len(fsconet)-4)&"_assr.csv"
				End If
				
				Set ta = fso.OpentextFile(fassr, ForAppending,True)
     			        ta.writeLine LigneAssr
				ta.Close	
   			End IF
		End If
   
  	wend
   	On Error GoTo 0
   	ts.Close
	If pasnet=1 Then tb.Close

	if pasnet=0 Then
   		fin=MsgBox( "Les fichier viennent d'tre crs au niveau du fichier "&fsconet&". Vous pouvez les utiliser pour importer les candidats dans Admin@ssr.",64,"Assr session 2007")
	Else
		fin=MsgBox( "Les fichiers viennent d'tre crs au niveau du fichier "&fsconet&". Vous pouvez les utiliser pour importer les candidats dans Admin@ssr.Certains enregistrements sont incomplets. Vous les retrouverez dans le fichier "&fscopanet&".",64,"Assr session 2007")
	End If

ElseIf not (fso.FileExists (fsconet)) and (RNE_Orig <> "") and (Type_Etab <> "") and (fsconet <> "") Then
	fin=MsgBox("Le fichier n'existe pas.",16,"Assr session 2007")
Else
	fin=MsgBox("Le fichier n'a pas t converti.",16,"Assr session 2007")
End If
